/*
  Name: Attribs.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - Attribute compatibility solution
*/

#ifndef _ATTRIBS_HPP
#define _ATTRIBS_HPP

#ifndef __packed
    #ifdef __GNUC__
        #define __packed __attribute__(( __packed__ ))
    #elif
        #define __packed
    #endif
#endif 

#ifndef __aligned
    #ifdef __GNUC__
        #define __aligned __attribute__(( __aligned__(16) ))
    #elif
        #define __aligned
    #endif
#endif 

#ifndef __pure
    #ifdef __GNUC__
        #define __pure __attribute__(( __pure__ ))
    #elif
        #define __pure
    #endif
#endif 

#ifndef __const_attr
    #ifdef __GNUC__
        #define __const_attr __attribute__(( __const__ ))
    #elif
        #define __const_attr
    #endif
#endif 

#ifndef __noreturn
    #ifdef __GNUC__
        #define __noreturn __attribute__(( __noreturn__ ))
    #elif
        #define __noreturn
    #endif
#endif 

// TODO: Is it possible to write it better?
#ifdef __GNUC__
    #define __clamp(num) (1.0f <? (0.0f >? num))
#elif
    #define __clamp(num) ((1.0f < ((0.0f > num) ? 0.0f : num) ) ? 1.0f : num)
#endif

#endif

