/*
  Name: aX_Timer.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - X (eXecution) Subsystem - Simple Timer
*/

#ifndef _AX_TIMER_HPP
#define _AX_TIMER_HPP

namespace Aegis {
    namespace X {
        class Timer;
    };
};    

namespace Aegis {
    namespace X {
        
        class Timer {
            private:
                int active;
                
                int delay;
                int time;
                
            public:
                __fastcall Timer();
                __fastcall Timer(int delay);
                __fastcall ~Timer();
                
                __fastcall void Enable(bool en = true);
                inline void Disable() { this->Enable( false ); };
                
                __fastcall void Reset();
                __fastcall void SetDelay(int delay);
                __fastcall int  Check(int t);

                __fastcall float Status();
        };
        
    };
};    

#endif

