/*
  Name: aG1_EffectiveGL.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem - G1 - some OpenGL betterups
*/

#ifndef _AG1_EFFECTIVEGL_HPP
#define _AG1_EFFECTIVEGL_HPP

#include <windows.h>
#include <gl/gl.h>

namespace Aegis {
    namespace G1 {

        // push matrix object - float version        
        class PushMatrixObjectf {
            private:
                bool b;
                float m[16];
                
            public:
                __fastcall PushMatrixObjectf();
                __fastcall ~PushMatrixObjectf();
        };    

        typedef PushMatrixObjectf PushMatrixObject;
        
    };
};    

#endif

