/*
  Name: aG1_RawBlock.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - G (Graphics) Subsystem - G1 - User block of OpenGL
*/

#ifndef _AG1_RAWBLOCK_HPP
#define _AG1_RAWBLOCK_HPP

#include "aG1_Renderer.hpp"

namespace Aegis {
    namespace G1 {

        // declaration
        class RawBlock {
            private:
                const Aegis::G1::Renderer & renderer;
                
            protected:
                virtual int Code(int param) = 0;
            
            public:
                __fastcall RawBlock( const Aegis::G1::Renderer & ren );
                __fastcall int Call( int param );
        };
        
    }; 
};

#endif

