/*
  Name: aM1_CommonMath.CPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - M (Math) Subsystem - M1 - Common math constants and funcs
*/

#include "aM1_CommonMath.hpp"

const float Aegis::M1::PI = 3.1415926535897932384626433832795f;
const float Aegis::M1::PI_180 = 0.0174532925199432957692369076848861f;
const float Aegis::M1::PI_4 = 1.5707963267948966192313216916398f;

__fastcall float Aegis::M1::Interpolate( float a, float b, float w ) {
    return b * w + a * (1.0f - w);
};    

