/*
  Name: aM2_Color.CPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - M (Math) Subsystem - M2 - Color Class
*/

#include "aM2_Color.hpp"

__fastcall void Aegis::M2::Color::Correct() {
    if (this->r < 0.0) this->r = 0.0;
    if (this->r > 1.0) this->r = 1.0;

    if (this->g < 0.0) this->g = 0.0;
    if (this->g > 1.0) this->g = 1.0;

    if (this->b < 0.0) this->b = 0.0;
    if (this->b > 1.0) this->b = 1.0;

    if (this->a < 0.0) this->a = 0.0;
    if (this->a > 1.0) this->a = 1.0;
    
    return;
};    

__fastcall void Aegis::M2::Color::PreMultiply() {
    
    this->r *= this->a;
    this->g *= this->a;
    this->b *= this->a;
 
    return;
};

