/*
  Name: aW_ExtraMenu.HPP
  Author: Jan Ringo, Tringi@Mx-3.cz, http://Tringi.Mx-3.cz
  Description: Aegis Engine - W (Window) Subsystem - System Menu extension
*/

#ifndef _AW_EXTRAMENU_HPP
#define _AW_EXTRAMENU_HPP

#include <windows.h>
#include "aW_Window.hpp"

namespace Aegis {
    namespace W {
        
        class ExtraMenu {
            private:
                Aegis::W::Window &wnd;
                HMENU hMenu;
                
            public:
                __fastcall ExtraMenu( Aegis::W::Window& );
                __fastcall ~ExtraMenu();
                
                bool ProcessMessage( HWND hwnd, UINT msg,
                                     WPARAM wParam, LPARAM lParam );
        };
        
    };
};

#endif

